"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.highlightPlugin = void 0;
var _react = _interopRequireDefault(require("react"));
var _adfSchema = require("@atlaskit/adf-schema");
var _commands = require("./commands");
var _pmPlugin = require("./pm-plugin");
var _ToolbarHighlightColor = require("./ui/ToolbarHighlightColor");
var highlightPlugin = exports.highlightPlugin = function highlightPlugin(_ref) {
  var _api$analytics;
  var api = _ref.api;
  var editorAnalyticsAPI = api === null || api === void 0 || (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  return {
    name: 'highlight',
    commands: {
      changeColor: (0, _commands.changeColor)(editorAnalyticsAPI)
    },
    marks: function marks() {
      return [{
        name: 'backgroundColor',
        mark: _adfSchema.backgroundColor
      }];
    },
    pmPlugins: function pmPlugins() {
      return [{
        name: 'highlight',
        plugin: function plugin() {
          return (0, _pmPlugin.createPlugin)({
            api: api
          });
        }
      }];
    },
    getSharedState: function getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return _pmPlugin.highlightPluginKey.getState(editorState);
    },
    primaryToolbarComponent: function primaryToolbarComponent(_ref2) {
      var editorView = _ref2.editorView,
        popupsMountPoint = _ref2.popupsMountPoint,
        popupsBoundariesElement = _ref2.popupsBoundariesElement,
        popupsScrollableElement = _ref2.popupsScrollableElement,
        disabled = _ref2.disabled,
        isToolbarReducedSpacing = _ref2.isToolbarReducedSpacing,
        dispatchAnalyticsEvent = _ref2.dispatchAnalyticsEvent;
      return /*#__PURE__*/_react.default.createElement(_ToolbarHighlightColor.ToolbarHighlightColorWithIntl, {
        popupsMountPoint: popupsMountPoint,
        popupsBoundariesElement: popupsBoundariesElement,
        popupsScrollableElement: popupsScrollableElement,
        disabled: disabled,
        isToolbarReducedSpacing: isToolbarReducedSpacing,
        dispatchAnalyticsEvent: dispatchAnalyticsEvent,
        pluginInjectionApi: api
      });
    }
  };
};