import { SafePlugin } from '@atlaskit/editor-common/safe-plugin';
import { REMOVE_HIGHLIGHT_COLOR } from '@atlaskit/editor-common/ui-color';
import { PluginKey } from '@atlaskit/editor-prosemirror/state';
export const highlightPluginKey = new PluginKey('highlight');
const initialState = {
  activeColor: REMOVE_HIGHLIGHT_COLOR,
  disabled: false // TODO: Should probably be true, but we can tackle it once we tackle disabled state
};
export let HighlightPluginAction = /*#__PURE__*/function (HighlightPluginAction) {
  HighlightPluginAction[HighlightPluginAction["CHANGE_COLOR"] = 0] = "CHANGE_COLOR";
  return HighlightPluginAction;
}({});
export const createPlugin = ({
  api
}) => {
  return new SafePlugin({
    key: highlightPluginKey,
    state: {
      init: () => initialState,
      apply: (tr, pluginState) => {
        var _tr$getMeta;
        const action = (_tr$getMeta = tr.getMeta(highlightPluginKey)) === null || _tr$getMeta === void 0 ? void 0 : _tr$getMeta.type;
        switch (action) {
          case HighlightPluginAction.CHANGE_COLOR:
            const {
              color
            } = tr.getMeta(highlightPluginKey);
            return {
              ...pluginState,
              activeColor: color
            };
          default:
            return pluginState;
        }
      }
    }
  });
};