import React from 'react';
import { backgroundColor } from '@atlaskit/adf-schema';
import { changeColor } from './commands';
import { createPlugin, highlightPluginKey } from './pm-plugin';
import { ToolbarHighlightColorWithIntl as ToolbarHighlightColor } from './ui/ToolbarHighlightColor';
export var highlightPlugin = function highlightPlugin(_ref) {
  var _api$analytics;
  var api = _ref.api;
  var editorAnalyticsAPI = api === null || api === void 0 || (_api$analytics = api.analytics) === null || _api$analytics === void 0 ? void 0 : _api$analytics.actions;
  return {
    name: 'highlight',
    commands: {
      changeColor: changeColor(editorAnalyticsAPI)
    },
    marks: function marks() {
      return [{
        name: 'backgroundColor',
        mark: backgroundColor
      }];
    },
    pmPlugins: function pmPlugins() {
      return [{
        name: 'highlight',
        plugin: function plugin() {
          return createPlugin({
            api: api
          });
        }
      }];
    },
    getSharedState: function getSharedState(editorState) {
      if (!editorState) {
        return;
      }
      return highlightPluginKey.getState(editorState);
    },
    primaryToolbarComponent: function primaryToolbarComponent(_ref2) {
      var editorView = _ref2.editorView,
        popupsMountPoint = _ref2.popupsMountPoint,
        popupsBoundariesElement = _ref2.popupsBoundariesElement,
        popupsScrollableElement = _ref2.popupsScrollableElement,
        disabled = _ref2.disabled,
        isToolbarReducedSpacing = _ref2.isToolbarReducedSpacing,
        dispatchAnalyticsEvent = _ref2.dispatchAnalyticsEvent;
      return /*#__PURE__*/React.createElement(ToolbarHighlightColor, {
        popupsMountPoint: popupsMountPoint,
        popupsBoundariesElement: popupsBoundariesElement,
        popupsScrollableElement: popupsScrollableElement,
        disabled: disabled,
        isToolbarReducedSpacing: isToolbarReducedSpacing,
        dispatchAnalyticsEvent: dispatchAnalyticsEvent,
        pluginInjectionApi: api
      });
    }
  };
};